﻿/*
 * Created by SharpDevelop.
 * User: bin
 * Date: 2014/1/20
 * Time: 15:00
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Threading;
using LuaInterface;

namespace CGE
{
	/// <summary>
	/// Description of Engine.
	/// </summary>
	public class Engine
	{
		private static int interval = 1000;
		private static Thread main;
		/// <summary>
		/// 清空屏幕
		/// </summary>
		/// <param name="color"></param>
		public static void cls(ConsoleColor color)
		{
			Console.BackgroundColor = color;
			Console.Clear();
		}
		
		/// <summary>
		/// 画点
		/// </summary>
		/// <param name="symbol"></param>
		/// <param name="color"></param>
		/// <param name="l"></param>
		public static void drawPoint(char symbol, ConsoleColor color, Point p){
			using (new Color(color)) {
				Console.SetCursorPosition(p.x * 2, p.y);
				Console.Write(symbol);
				Console.SetCursorPosition(0, 0);
			}
		}
		/// <summary>
		/// 画字符串
		/// </summary>
		/// <param name="str"></param>
		/// <param name="color"></param>
		/// <param name="r"></param>
		public static void drawText(String str, ConsoleColor color, Rect r){
			using (new Color(color)) {
				int x = r.x  * 2;
				int y = r.y;
				int row = 0;
				if(r.width<=0 || r.height<=0) return;
				while (true) {
					if(row>=r.height) return;
					if(str.Length <= row * r.width) return;
					Console.SetCursorPosition(x, y+row);
					int len = Math.Min(r.width, str.Length-row*r.width);
					for (int i = 0; i < len; i++) {
						char c = str[row*r.width+i];
						Console.Write(c);
						if(c<128){
							Console.Write(' ');
						}
					}	
					row++;					
				}	
			}
		}
		
		public static void drawLine(char symbol, ConsoleColor color, Rect r){
			using (new Color(color)) {
				
			}
		}
		
		public static void drawRect(char symbol,ConsoleColor color, Rect r){
			using (new Color(color)) {
				Console.SetCursorPosition(r.x * 2, r.y);				
				Console.Write(new string(symbol, r.width));
				for (int i = 1; i < r.height-1; i++) {
					Console.SetCursorPosition(r.x * 2, r.y+i);
					Console.Write(symbol);
					Console.SetCursorPosition(r.x * 2 + r.width*2-2, r.y+i);
					Console.Write(symbol);
				}
				Console.SetCursorPosition(r.x * 2, r.y+r.height-1);
				Console.Write(new string(symbol, r.width));
				Console.SetCursorPosition(0, 0);
			}
		}
		
		public static void fillRect(char symbol, ConsoleColor color, Rect r){
			using (new Color(color)) {
				var str = new string(symbol, r.width);
				for (int i = 0; i < r.height; i++) {
					Console.SetCursorPosition(r.x * 2, r.y+i);	
					Console.Write(str);
				}				
				Console.SetCursorPosition(0, 0);
			}
		}
		
		static void GameInput(object state)
		{
			while (true) {
				var key = Console.ReadKey(true);
				lock(typeof(Engine)){
					EngineImport.keypress(key.KeyChar.ToString().ToUpper());
				}
				Thread.Sleep(0);
			}
			
		}
		
		public static void Start()
		{
			main = Thread.CurrentThread;
			cls(Console.BackgroundColor);
			
			ThreadPool.QueueUserWorkItem(GameRun);
			ThreadPool.QueueUserWorkItem(GameInput);
		}
		
		static void GameRun(Object state){
			EngineImport.gameInit();
			while (true) {
				var now = DateTime.Now.Ticks;
				EngineImport.gameLoop();	
				var used =(int)(DateTime.Now.Ticks - now)/10000;//游戏渲染等 用掉的时间
				if(interval>used){
					//时间间隔订正
					Thread.Sleep(interval-used);
				}
			}
		}
		
		public static void setTitle(string title)
		{
			Console.Title = title;
		}
		
		public static void setSpeed(double speed)
		{
			var d = 1000/speed;
			interval = Convert.ToInt32(d);
		}
		
		public static void quit()
		{
			if(main!=null){
				main.Interrupt();
			}
		}
	}
}
