﻿/*
 * 由SharpDevelop创建。
 * 用户： bin
 * 日期: 2014/1/20
 * 时间: 17:22
 * 
 */
using System;
using LuaInterface;

namespace CGE
{
	/// <summary>
	/// Description of EngineExport.
	/// </summary>
	public static class EngineExport
	{
		[Export]
		public static void cls(string color){
			Engine.cls(GetColor(color));
		}
		
		[Export]
		public static void drawPoint(int symbolIndex, LuaTable table){
			var p = new Point();
			p.x = GetX(table);
			p.y = GetY(table);
			Engine.drawPoint(Symbols.CharAt(symbolIndex), GetColor(table), p);
		}
		
		
		
		[Export]
		public static void drawText(String stringIndex, LuaTable table){
			Engine.drawText(Strings.StringAt(stringIndex), GetColor(table), GetRect(table));
		}
		
		[Export]
		public static void fillRect(int symbolIndex, LuaTable table){
			Engine.fillRect(Symbols.CharAt(symbolIndex), GetColor(table), GetRect(table));
		}
		
		[Export]
		public static void drawRect(int symbolIndex, LuaTable table){
			Engine.drawRect(Symbols.CharAt(symbolIndex), GetColor(table), GetRect(table));
		}
		
		[Export]
		public static void set(LuaTable table){
			Engine.setTitle(Strings.StringAt((string)table["title"]));
			Engine.setSpeed((double)table["speed"]);
		}
		
		[Export]
		public static void quit(){
			Engine.quit();
		}
		
		#region	Private Methods
		private static ConsoleColor GetColor(LuaTable table)
		{
			return GetColor((string)table["color"]);
		}
		
		private static ConsoleColor GetColor(string color)
		{
			try {							
				return (ConsoleColor)ConsoleColor.Parse(typeof(ConsoleColor), color);
			} catch (Exception) {
				return Console.ForegroundColor;
			}	
		}
		
		private static Rect GetRect(LuaTable table)
		{
			Rect r = new Rect();
			r.x = GetX(table);
			r.y = GetY(table);
			r.width = Convert.ToInt32(table["width"]);
			r.height = Convert.ToInt32(table["height"]);
			return r;
		}
		
		static int GetX(LuaTable table)
		{
			return Convert.ToInt32(table["x"]);
		}
		
		static int GetY(LuaTable table)
		{
			return Convert.ToInt32(table["y"]);
		}
		#endregion
	}
}
