﻿/*
 * 由SharpDevelop创建。
 * 用户： bin
 * 日期: 2014/1/20
 * 时间: 16:55
 * 
 */
using System;
using System.Collections.Generic;
using System.IO;

namespace CGE
{
	/// <summary>
	/// Description of Symbols.
	/// </summary>
	public class Strings
	{
		private static Dictionary<String, String> resources;
		static Strings()
		{
			var file = AppDomain.CurrentDomain.BaseDirectory+"strings.txt";
			if(File.Exists(file))
			{
				var lines = File.ReadAllLines(file);
				resources = new Dictionary<string, string>(lines.Length);
				foreach (var line in lines) {
					var index = line.IndexOf('=');
					if(index>0)
					{
						string key = line.Substring(0, index).Trim();
						string value = line.Substring(index+1).Trim();
						resources[key] = value;
					}
				}				
			}
		}
		public static string StringAt(string index)
		{
			if(resources.ContainsKey(index))
			{
				return resources[index];
			}
			return index;
		}
	}
}
