local  snake

function keypress(key)
	if key=='W' and snake.dir ~= 'D' then snake.dir = 'U' 
	elseif key=='A' and snake.dir ~= 'R' then snake.dir = 'L' 
	elseif key=='S' and snake.dir ~= 'U' then snake.dir = 'D'
	elseif key=='D' and snake.dir ~= 'L' then snake.dir = 'R'
	end
end
function gameLoop()
	if snake.dead then return end
	snake.move()
	gameDraw()
end
function gameInit()	
	set({title='title', speed=4})
	edge = {0, 0, 30, 25}
	drawRect(7, {x = edge[1], y = edge[2], width = edge[3], height = edge[4], color='White'})	
	drawRect(5, {x = edge[3], y=edge[2], width = 40-edge[3], height=edge[4], color='Cyan'})
	drawText('str2',{x=31, y=3, width=40-edge[3]-2, height=1, color='Yellow'})
	drawText('author',{x=31, y=4, width=30, height = 1, color='White'})
	drawText('desc',{x=31, y=19, width=30, height = 1, color='DarkMagenta'})
	drawText('cmd1',{x=31, y=20, width=30, height = 1, color='DarkGreen'})
	drawText('cmd3',{x=31, y=22, width=30, height = 1, color='DarkGreen'})
	math.randomseed(os.time())

	snake = {
		header = {15,12},
		points = {{15,12},{15,13}},
		tail = {15,13},
		dir = 'U',
		dead = false,
		move=function ()
			local point
			if snake.dir=='U' then
				point = {snake.header[1], snake.header[2]-1}
			elseif snake.dir=='L' then
				point = {snake.header[1]-1, snake.header[2]}
			elseif snake.dir=='D' then
				point = {snake.header[1], snake.header[2]+1}
			elseif snake.dir=='R' then
				point = {snake.header[1]+1, snake.header[2]}
			end
			snake.dead = isDead(point)
			
			if snake.dead then
				drawGameOver()
			else
				snake.header = point
				table.insert(snake.points, 0, point)
				if snake.header[1]~=food[1] or snake.header[2]~=food[2] then 
					local n = table.getn(snake.points)
					table.remove(snake.points, n)
					if n>0 then snake.tail = snake.points[n-1] end
				else
					food = newfood()
				end
			end
		end
	}
	food = newfood()
end
function newfood()
	local x,y,flag
	while true do
		x = math.random(1, 28)
		y = math.random(1, 22)
		flag = true
		for i=1,#(snake.points)-1 do
			if snake.points[i][1]==x and snake.points[i][2]==y then
				flag = false
				break
			end
		end
		if flag then return {x, y} end
	end
end
function isDead(point)
	if point[1]<=0 or point[2]<=0 then
		return true
	elseif point[1]>=edge[3]-1 or point[2]>=edge[4]-1 then
		return true
	else
		for i=1,#(snake.points)-1 do
			if snake.points[i][1]==point[1] and snake.points[i][2]==point[2] then
				return true
			end
		end
	end
	return false
end
function gameDraw()
	drawPoint(2, {x=food[1], y=food[2]})
	drawPoint(3, {x=snake.header[1], y=snake.header[2], color='Blue'})
	drawPoint(0, {x=snake.tail[1], y=snake.tail[2], color='Black'})
end
function drawGameOver()
	fillRect(0, {x=1, y=1, width=28, height=23, color='Black'})
	drawText('Game Over!',{x=10, y=5, width=28, height=1, color='White'})
end